#-------------------------------------------------------------------#
# Yamms.pl							    #
#-------------------------------------------------------------------#
# YaMMS 4 YaBB21						    #
# Version 2.04							    #
# by Carsten Dalgaard						    #
#-------------------------------------------------------------------#
# Copyright: 2006 'Carsten Dalgaard' - All Rights Reserved	    #
# Released: August 6, 2006					    #
# e-mail: carsten.dalgaard@gmail.com				    #
#-------------------------------------------------------------------#
# Any redistribution of this script without the expressed written   #
# consent of 'Carsten Dalgaard' is strictly prohibited. Copying     #
# any	of the code contained within this script and claiming it as #
# your own is also prohibited.					    #
#-------------------------------------------------------------------#
# By using this script you agree to indemnify 'Carsten Dalgaard'    #
# from any liability that might arise from its use.		    #
#-------------------------------------------------------------------#
# You may not remove any of these header notices.		    #
#-------------------------------------------------------------------#

LoadLanguage("yamms");

if(!-e ("$vardir/continent.txt") || !-e ("$vardir/country.txt")) {
	&makemaps;
}

sub MMall {

my $user = $INFO{'username'};
if (!${$uid.$user}{'password'}){&LoadUser($user);}

fopen(FILE, "$vardir/continent.txt");
@continent = <FILE>;
$contcount = @continent;
fclose(FILE);
chomp @continent;

for($i=0;$i<$contcount;$i++) { $membamount[$i] = 0; }

$mapmemcount = 0;

&ManageMemberinfo("load");
if(!-e ("$vardir/mmlist.txt")) {
	fopen(MMLIST, ">$vardir/mmlist.txt", 1);
	while (($membname, $value) = each(%memberinf)) {
		if(!${$uid.$membname}{'password'}) { &LoadUser($membname); }
		if(${$uid.$membname}{'xcoord'}) { print MMLIST "$membname\n"; }
	}
	fclose(MMLIST);
}

fopen(MMLIST, "$vardir/mmlist.txt");
@mmlist = <MMLIST>;
fclose(MMLIST);

foreach $mmbname (@mmlist) {
	chomp $mmbname;
	if(!exists $memberinf{$mmbname}) { next; }
	if(!${$uid.$mmbname}{'password'}){ &LoadUser($mmbname); }
	if(${$uid.$mmbname}{'xcoord'}) {
		if(${$uid.$mmbname}{'state'}) { $sortstate = ${$uid.$mmbname}{'state'}; }
		else {$sortstate = "zzz";}
		$templist[$mapmemcount] .= qq~${$uid.$mmbname}{'country'}|$sortstate|${$uid.$mmbname}{'realname'}|$mmbname~;
		$mapmemcount++;
		for($x=0;$x<$contcount;$x++) {
			$continent[$x] =~ s/ //gi;
			$continent[$x] =~ s/\n//gi;
			$continent[$x] =~ s/\r//gi;
			if(lc(${$uid.$mmbname}{'map'}) eq lc($continent[$x])) { $membamount[$x]++; }
		}
	}
}
undef %memberinf;

@SortAList = sort{lc($a) cmp lc($b)} (@templist);

for($i=0;$i<$mapmemcount;$i++) {
	chomp $SortAList[$i];
	(undef, undef, undef, $SortList[$i]) = split(/\|/, $SortAList[$i]);
}

@membername = ();
chomp(@SortList);
@membername = @SortList;

if($mapmemcount == 0) {
$yymain .= qq~
<table align="center" width="700" cellpadding="0" cellspacing="0" border="0">
<tr><td align="left" valign="middle">
<div class="titlebg" style="position: relative; float: left; width: 700px; padding: 2px; border: 1px black solid; border-bottom: 0px;">
<img src="$modimgurl/yamms/map.gif" alt="" border="0" style="vertical-align: middle;" /> $maptxt{'01'}
</div>
<div class="windowbg" align="center" style="position: relative; float: left; width: 700px; margin-bottom: 8px; padding: 2px; border: 1px black solid; border-top: 0px;">
$maptxt{'35'}
</div>
</td>
</tr>
</table>
~;
	$yytitle = "$maptxt{'01'}";
	&template;
	exit;
}

if($INFO{'defmap'}) { $defmap = $INFO{'defmap'}; }
elsif(${$uid.$user}{'map'}) { $defmap = ${$uid.$user}{'map'}; }
else { $defmap = ""; }

@sortcontinent = ();
$continmemb = 0;
$defmapexist = 0;
for($x=0;$x<$contcount;$x++) {
	if($membamount[$x] > 0) {
		$continmemb++;
		$onecont = $x;
	}
	$sortamount = $membamount[$x] + 1000000;
	$sortcontinent[$x] = qq~$sortamount|$continent[$x]~;
	if($defmap eq $continent[$x]) { $defmapexist = 1; }
}

if(!$defmapexist) { $defmap = ""; }

@sortclist = sort{$b <=> $a} (@sortcontinent);

@member = ();
$x = 0;
$y = 0;
$contopt = "";

if($continmemb > 1) {
	$contopt .= qq~<form method="post" action="$scripturl?action=mmall2" name="membmark" style="display: inline">~;
	$contopt .= qq~<select class="titlebg" style="width: 150px; font-size: 11px; font-weight: normal;" name="contselect" onchange="submit()">~;
	foreach $sortcurcontinent (@sortclist) {
		($memamount, $curcontinent) = split(/\|/, $sortcurcontinent);
		$thisamount = $memamount - 1000000;
		if($thisamount > 0) {
			if($y == 0 && !$defmap) {$defmap = $curcontinent;}
			$y++;
			$curcontinent =~ s/ //gi;
			$curcontinent =~ s/\n//gi;
			$curcontinent =~ s/\r//gi;
			$cselektet = "";
			if($defmap eq $curcontinent) { $cselektet = "selected = 'selected'" }
			$thecvalue = $curcontinent;
			$thecopt = $curcontinent;
			$thecopt =~ s/\_/ /g;
			$contopt .= qq~<option value="$thecvalue" $cselektet>$thecopt ($thisamount)</option>~;
		}
		$x++;
	}
	$contopt .= qq~</select>~;
	$contopt .= qq~</form>~;
}
else {
	$curcontinent = $continent[$onecont];
	$defmap = $curcontinent;
	$curcontinent =~ s/ //gi;
	$curcontinent =~ s/\n//gi;
	$curcontinent =~ s/\r//gi;
	$curcontinent =~ s/\_/ /g;
	$contopt .= qq~<span style="font-size: 11px;"><b>$curcontinent</b> ($membamount[$onecont])</span>~;
}
$titlemap = $defmap;
$titlemap =~ s/\_/ /g;
$gallerydel = "";
# if($ENV{'HTTP_USER_AGENT'} =~ /MSIE/) {$gallerydel = qq~ galleryimg="no"~;}

$yymain .= qq~

<script language="JavaScript1.2" type="text/javascript">
<!--
  img1 = new Image();
  img1.src = "$modimgurl/yamms/bpin.gif";
  img2 = new Image();
  img2.src = "$modimgurl/yamms/gpin.gif";
  img3 = new Image();
  img3.src = "$modimgurl/yamms/rpin.gif";
  img4 = new Image();
  img4.src = "$modimgurl/yamms/bpin_on.gif";
  img5 = new Image();
  img5.src = "$modimgurl/yamms/gpin_on.gif";
  img6 = new Image();
  img6.src = "$modimgurl/yamms/rpin_on.gif";
// -->
</script>

<div style="width: 734px; margin-left: auto; margin-right: auto;">

<div class="titlebg" style="float: left; width: 730px; border: 1px black solid; border-bottom: 0px;">
<div style="float: left; width: 550px; padding-top: 2px; padding-bottom: 2px;">
&nbsp; <img src="$modimgurl/yamms/map.gif" alt="" border="0" style="vertical-align: middle;" /> $maptxt{'01'} - $titlemap
</div>
<div align="center" style="float: right; width: 180px; padding-top: 2px; padding-bottom: 2px;">
$contopt
</div>
</div>

<div class="windowbg2" style="float: left; width: 730px; border: 1px black solid;">
<div id="mapcontainer" style="position: relative; float: left; overflow: hidden; width: 550px; height: 430px;">
<div id="map" style="position: absolute; top: 0; left: 0; float: left; width: 550px; height: 430px;">
	<img src="$modimgurl/yamms/maps/$defmap.gif" alt="" id="aktmap" name="aktmap" width="550" height="430" style="float: left; width: 550px; height: 430px; z-index: 0;"$gallerydel />
	<img src="$modimgurl/yamms/blpin.gif" alt="" id="nmarker" name="pinview" onclick="MembLink()" style="z-index: 100000; cursor: hand; visibility: hidden" border="0" />
~;

$b = 2;
$optname = "";
$firstlett = "";
$firststate = "";
$memnr = 0;
$origpos = qq~"", ~;

fopen(FILE, "$vardir/log.txt");
@entries = <FILE>;
fclose(FILE);

$optname = qq~<div style="width: 157px; padding-top: 4px; padding-bottom: 4px; margin-left: auto; margin-right: auto;">~;
for($i=0;$i<$mapmemcount;$i++) {
	chomp(@membername);
	if (!${$uid.$membername[$i]}{'password'}){&LoadUser($membername[$i]);}
	$membername[$i] =~ s/ //gi;
	$membername[$i] =~ s/\n//gi;
	$membname = $membername[$i];

	if(${$uid.$membname}{'xcoord'} ne "") {
		$zb = $b;
		$membx = 0;
		$memby = 0;
		if(lc(${$uid.$membname}{'map'}) eq lc($defmap)) {
			my $optionname = "";
			$memb_on = 0;
			$memnr++;
			foreach $curentry (@entries) {
				chomp $curentry;
				($onname, $onvalue) = split(/\|/, $curentry);
				if(lc $onname eq lc $membname) {
					$memb_on = 1;
					$zb = $b + 50000;
				}
			}

			if(${$uid.$membname}{'gender'} eq "Male") {
				$pin = $malepin;
				if($memb_on) { $pin .= "_on"; }
			}
			elsif(${$uid.$membname}{'gender'} eq "Female") {
				$pin = $femalepin;
				if($memb_on) { $pin .= "_on"; }
			}
			else {
				$pin = $napin;
				if($memb_on) { $pin .= "_on"; }
			}
			$pinloc = "";
			if(${$uid.$membname}{'location'}) {$pinloc = qq~, ${$uid.$membname}{'location'}~;}
			my $pinlabel = qq~${$uid.$membname}{'realname'}$pinloc~;
			$cmembx = ${$uid.$membname}{'xcoord'};
			$cmemby = ${$uid.$membname}{'ycoord'} - 8;
			$origpos .= qq~"$cmembx|$cmemby", ~;
   			$cmembx .= 'px';
			$cmemby .= 'px';
			$yymain .= qq~
				<a href="$scripturl?action=viewprofile;username=$membname"><img src="$modimgurl/yamms/$pin.gif" id="pinnr$memnr" style="position: absolute; z-index: $zb; top: $cmemby; left: $cmembx; display: block;" border="0" alt="$pinlabel" /></a>
			~;

			if (length(${$uid.$membname}{'realname'}) > 18) {
				$longname = substr(${$uid.$membname}{'realname'},0,15);
				$optionname = qq~$longname...~;
			}
			else {
				$optionname = ${$uid.$membname}{'realname'};
			}
			$startlett = ${$uid.$membname}{'country'};
			$startstate = ${$uid.$membname}{'state'};
			if($startlett ne $firstlett) {
				$firstlett = $startlett;
				$indxheadr = $startlett;
				$indxheadr =~ s/\_/ /g;
				$optname .= qq~<span class="titlebg" style="float: left; text-align: left; vertical-align: middle; width: 134px; height: 15px; font-size: 10px; font-weight: normal; border: 1px black solid; border-right: 0px; margin-top: 1px; overflow: hidden;">&nbsp;$indxheadr</span>~;
				$optname .= qq~<span class="titlebg" style="float: left; text-align: right; width: 21px; height: 15px; font-size: 10px; font-weight: normal; border: 1px black solid; border-left: 0px; margin-top: 1px; overflow: hidden;"><img src="$modimgurl/yamms/flag/$startlett.gif" alt="" /><br /></span>~;
			}
			if(-e ("$vardir/$startlett.txt") && $startstate ne $firststate) {
				$firststate = $startstate;
				($indxinit, $indxheadr) = split(/\,/, $startstate);
				if(!$indxheadr) { $indxheadr = $maptxt{'38'} }
				$indxheadr =~ s/\_/ /g;
				$optname .= qq~<span class="catbg" style="float: left; text-align: left; width: 156px; padding: 1px; padding-right: 0px; font-size: 10px; font-weight: normal; margin-top: 1px; overflow: hidden;">&nbsp;$indxheadr</span>~;
			}
			$optname .= qq~<span class="small" id="$membname" style="float: left; text-align: left; width: 153px; font-size: 10px; padding-left: 4px; padding-bottom: 1px; cursor: pointer; cursor: hand; overflow: hidden;" onclick="ViewMemb('$cmembx','$cmemby','$membname')"><img src="$modimgurl/yamms/blpin.gif" border="0" alt="" id="marker$membname" style="visibility: hidden;" /> $optionname</span>~;
			$b++;
		}
	}
}
$optname .= qq~</div>~;
$yymain .= qq~
</div></div>

<div class="windowbg2" align="center" id="memblist" style="float: right; width: 178px; height: 280px; border-left: 1px black solid; overflow: auto;">
	$optname
</div>
<div class="catbg" align="center" id="navigation" style="float: right; border-top: 1px black solid; border-left: 1px black solid; width: 178px; height: 149px;">
<div align="center" style="float: left; width: 176px; padding-top: 8px;">
<input value="100%" size="4" name="zoompct" id="zoompct" style="font-size: 10px; font-weight: bold; border: 1px black solid; padding: 1px" readonly="readonly" />
</div>
<div align="center" style="float: left; width: 176px; padding-top: 6px;">
<img src="$modimgurl/yamms/zoom_in.gif" width="22" height="22" alt="$maptxt{'78'}" border="0" style="vertical-align: middle; cursor: pointer; cursor: hand;" onmousedown = "startzoom('zoomin')" onmouseup = "stopzoom()" onmouseout = "stopzoom()" />
<img src="$modimgurl/yamms/zoom_no.gif" width="22" height="22" alt="$maptxt{'79'}" border="0" style="vertical-align: middle; cursor: pointer; cursor: hand;" onclick = "startzoom('normal')" />
<img src="$modimgurl/yamms/zoom_out.gif" width="22" height="22" alt="$maptxt{'80'}" border="0" style="vertical-align: middle; cursor: pointer; cursor: hand;" onmousedown = "startzoom('zoomout')" onmouseup = "stopzoom()" onmouseout = "stopzoom()" />
</div>
<div align="center" style="float: left; width: 176px; padding-top: 10px;">
<img src="$modimgurl/yamms/scroll_up.gif" width="22" height="22" alt="$maptxt{'81'}" border="0" style="vertical-align: middle; cursor: pointer; cursor: hand;" onmousedown = "scrollup()" onmouseup = "stopscroll()" onmouseout = "stopscroll()" />
</div>
<div align="center" style="float: left; width: 176px; padding-top: 3px;">
<img src="$modimgurl/yamms/scroll_left.gif" width="22" height="22" alt="$maptxt{'82'}" border="0" style="vertical-align: middle; cursor: pointer; cursor: hand;" onmousedown = "scrollright()" onmouseup = "stopscroll()" onmouseout = "stopscroll()" />
<img src="$modimgurl/yamms/scroll_center.gif" width="22" height="22" alt="$maptxt{'85'}" border="0" style="vertical-align: middle; cursor: pointer; cursor: hand;" onclick = "scrollcenter()" />
<img src="$modimgurl/yamms/scroll_right.gif" width="22" height="22" alt="$maptxt{'83'}" border="0" style="vertical-align: middle; cursor: pointer; cursor: hand;" onmousedown = "scrollleft()" onmouseup = "stopscroll()" onmouseout = "stopscroll()" />
</div>
<div align="center" style="float: left; width: 176px; padding-top: 3px;">
<img src="$modimgurl/yamms/scroll_down.gif" width="22" height="22" alt="$maptxt{'84'}" border="0" style="vertical-align: middle; cursor: pointer; cursor: hand;" onmousedown = "scrolldown()" onmouseup = "stopscroll()" onmouseout = "stopscroll()" />
</div>
</div>
</div>
<div class="catbg" style="float: left; width: 730px; border: 1px black solid; border-top: 0px; margin-bottom: 8px;">
<div class="small" align="center" style="float: left; width: 550px; padding-top: 4px; padding-bottom: 4px;">
~;
if($malepin ne $femalepin || $femalepin ne $napin || $malepin ne $napin) {
	$yymain .= qq~<img src="$modimgurl/yamms/$malepin.gif" alt="" /> $maptxt{'08'}&nbsp; <img src="$modimgurl/yamms/$femalepin.gif" alt="" /> $maptxt{'09'}&nbsp; <img src="$modimgurl/yamms/$napin.gif" alt="" /> $maptxt{'10'}~;
}
$yymain .= qq~
</div>
<div align="center" style="float: left; width: 180px; padding-top: 4px; padding-bottom: 4px;">
~;
if(!$iamguest) {
$yymain .= qq~
<input type="button" class="catbg" value="$maptxt{'32'}" style="width: 150px; font-size: 11px; font-weight: normal; border: 1px gray outset; display: inline;" onclick="location.href='$scripturl?action=profileCheck;username=$username;locsid=1'" />
~;
}

$yymain .= qq~
</div>
</div>

<div style="clear: both;"></div>
</div>

<script language="JavaScript1.2">

var membername;
var membernum = '$memnr';
var steppct = 0.02;
var move_left = 0;
var move_top = 0;
var org_width = 550;
var org_height = 430;
var new_width = 550;
var new_height = 430;
var scrollspeed = 5;
var tmpmove_left = 0;

org_pos = new Array ( $origpos"" );

function ViewMemb(kordx, kordy, memname) {
	newkordx = parseInt(kordx);
	newkordy = parseInt(kordy);
	thekordx = Math.round(newkordx + (newkordx * move_left))+'px';
	thekordy = Math.round(newkordy + (newkordy * move_top))+'px';
	document.getElementById("nmarker").style.visibility = "hidden";
	document.getElementById("nmarker").style.position = "absolute";
	document.getElementById("nmarker").style.left = thekordx;
	document.getElementById("nmarker").style.top = thekordy;
	document.getElementById("nmarker").style.visibility = "visible";
	document.getElementById(memname).className = "windowbg";
	document.getElementById("marker"+memname).style.visibility = "visible";
	if (membername && membername != memname) {
		document.getElementById(membername).className = "small";
		document.getElementById("marker"+membername).style.visibility = "hidden";
	}
	membername = memname;
}

function MembLink() {
	location.href="$scripturl?action=viewprofile;username="+membername;
}

function dozoom() {
	if ((new_width > 400 || directions > 0) && (tmpmove_left < 200 || directions < 0)) {
		new_width = parseInt(themap.width);
		new_height = parseInt(themap.height);
		var srmove_left = Math.round(org_width * directions / 2);
		var srmove_top = Math.round(org_height * directions / 2);
		var grow_width = Math.round(new_width + (org_width * directions));
		var grow_height = Math.round(new_height + (org_height * directions));
		themap.width = grow_width+'px';
		themap.height = grow_height+'px';
		document.getElementById("map").style.left=parseInt(document.getElementById("map").style.left)-srmove_left+"px";
		document.getElementById("map").style.top=parseInt(document.getElementById("map").style.top)-srmove_top+"px";
		tmpmove_left = (grow_width - org_width) * 100 / org_width;
		tmpmove_top = (grow_height - org_height) * 100 / org_height;
		move_left = tmpmove_left / 100;
		move_top = tmpmove_top / 100;
		for (i=1; i<=membernum; i++) {
			var value = org_pos[i].split("|");
			var valuel = parseInt(value[0]);
			var valuet = parseInt(value[1]);
			var pin_left = Math.round(valuel + (valuel * move_left));
			var pin_top = Math.round(valuet + (valuet * move_top));
			document.getElementById('pinnr'+i).style.left = pin_left+'px';
			document.getElementById('pinnr'+i).style.top = pin_top+'px';
		}
		if (themark.visibility == "visible") {
			var valueml = parseInt(newkordx);
			var valuemt = parseInt(newkordy);
			var mark_left = Math.round(valueml + (valueml * move_left));
			var mark_top = Math.round(valuemt + (valuemt * move_top));
			themark.left = mark_left+'px';
			themark.top = mark_top+'px';
		}
		document.getElementById('zoompct').value = Math.round(tmpmove_left + 100)+'%';
	}
}

function stopzoom() {
	if (window.nowsize) clearInterval(nowsize);
}

function startzoom(zooming) {
	if (zooming == "zoomin") directions = steppct;
	else directions = 0 - steppct;
	themap = document.getElementById('aktmap').style;
	themark = document.getElementById('nmarker').style;
	if (zooming == "normal") {
		themap.width = org_width+'px';
		themap.height = org_height+'px';
		move_left = 0;
		move_top = 0;
		tmpmove_left = 0;
		new_width = 550;
		new_height = 430;
		for (i=1; i<=membernum; i++) {
			var value = org_pos[i].split("|");
			document.getElementById("pinnr"+i).style.left = value[0]+'px';
			document.getElementById("pinnr"+i).style.top = value[1]+'px';
		}
		if (themark.visibility == "visible") {
			themark.left = newkordx+'px';
			themark.top = newkordy+'px';
		}
		document.getElementById("map").style.top = 0;
		document.getElementById("map").style.left = 0;
		document.getElementById("zoompct").value = '100%';
		return;
	}
	else {
		dozoom();
	}
	nowsize = setInterval("dozoom()", 100);
}

function scrollcenter(){
	if (new_width > org_width) {
		var center_left = Math.round((org_width - new_width) / 2);
		var center_top = Math.round((org_height - new_height) / 2);
		document.getElementById("map").style.left = center_left+"px";
		document.getElementById("map").style.top = center_top+"px";
	}
}

function scrollleft() {
	if (parseInt(document.getElementById("map").style.left) >= (new_width * (-1) + 540)) {
		document.getElementById("map").style.left=parseInt(document.getElementById("map").style.left)-scrollspeed+"px";
	}
	scrollleftvar=setTimeout("scrollleft()",20);
}

function scrollright(){
	if (parseInt(document.getElementById("map").style.left) <= 0) {
		document.getElementById("map").style.left=parseInt(document.getElementById("map").style.left)+scrollspeed+"px";
	}
	scrollrightvar=setTimeout("scrollright()",20);
}

function scrolldown() {
	if (parseInt(document.getElementById("map").style.top) >= (new_height * (-1) + 420)) {
		document.getElementById("map").style.top=parseInt(document.getElementById("map").style.top)-scrollspeed+"px";
	}
	scrolldownvar=setTimeout("scrolldown()",20);
}

function scrollup(){
	if (parseInt(document.getElementById("map").style.top) <= 0) {
		document.getElementById("map").style.top=parseInt(document.getElementById("map").style.top)+scrollspeed+"px";
	}
	scrollupvar=setTimeout("scrollup()",20);
}

function stopscroll(){
	if (window.scrollleftvar) clearTimeout(scrollleftvar);
	if (window.scrollrightvar) clearTimeout(scrollrightvar);
	if (window.scrollupvar) clearTimeout(scrollupvar);
	if (window.scrolldownvar) clearTimeout(scrolldownvar);
}

</script>
~;
	$yytitle = "$maptxt{'01'}";
	&template;
	exit;
}

sub MMall2 {
$INFO{'defmap'} = $FORM{'contselect'};
&MMall;
}

sub makemaps {
if(!-e ("$vardir/continent.txt")) {
	opendir(DIR, "$modimgdir/yamms/maps") || &fatal_error("$maptxt{'39'} ($modimgdir/yamms/maps)!");
	@contents = readdir(DIR);
	closedir(DIR);
	fopen(FILE, ">$vardir/continent.txt", 1);
	foreach $line (sort @contents){
		($name, $extension) = split (/\./, $line);
		if ($extension =~ /gif/i){
			print FILE "$name\n";
		}
	}
	fclose(FILE);
}
if(!-e ("$vardir/country.txt")) {
	opendir(DIR, "$modimgdir/yamms/flag") || &fatal_error("$maptxt{'39'} ($modimgdir/yamms/flag)!");
	@flcontents = readdir(DIR);
	closedir(DIR);
	fopen(FILE, ">$vardir/country.txt", 1);
	foreach $flline (sort @flcontents){
		($flname, $flextension) = split (/\./, $flline);
		if ($flextension =~ /gif/i){
			print FILE "$flname\n";
		}
	}
	fclose(FILE);
}
}

sub MapButton {
$yymain .= qq~
<input type="button" value="Member Map" onclick="location.href='$scripturl?action=membermap;username=$username'" />
~;
}

sub ModifyProfileLocation {
	require "$sourcedir/Profile.pl";

	# Check SID is valid
	&SidCheck;

	&PrepareProfile;
	my $user = $INFO{'username'};
	if (!${$uid.$user}{'password'}){&LoadUser($user);}
	$menucolors[1] = "titlebg";
	$modsection = qq~- $profile_txt{'227'}~;
	&ProfileMenu;

	fopen(FILE, "$vardir/continent.txt");
	@continent = <FILE>;
	$numcontinent = @continent;
	fclose(FILE);
	foreach (@continent) { $_ =~ s~[\n\r]~~g; }

	if(!${$uid.$user}{'map'}) { $defaultmap = $continent[0] }
	else { $defaultmap = ${$uid.$user}{'map'}}

	foreach $curcontinent (@continent) {
		$curcontinent =~ s/ //gi;
		$curcontinent =~ s/\n//gi;
		$curcontinent =~ s/\r//gi;
		$cselektet = "";
		if(lc($curcontinent) eq lc(${$uid.$user}{'map'})) { $cselektet = ' selected="selected" ' }
		$thecvalue = $curcontinent;
		$thecopt = $curcontinent;
		$thecopt =~ s/\_/ /g;
		$contopt .= qq~<option value="$thecvalue"$cselektet>$thecopt</option>\n~;
	}

	fopen(FILE, "$vardir/country.txt");
	@country = <FILE>;
	$numcountry = @country;
	fclose(FILE);
	chomp @country;
	$statvar = qq~"", ~;
	foreach $curcountry (sort @country) {
		unless($curcountry eq "Noflag") {
			$curcountry =~ s/ //gi;
			$curcountry =~ s/\n//gi;
			$curcountry =~ s/\r//gi;
			$selektet = "";
			if($curcountry eq ${$uid.$user}{'country'}) { $selektet = ' selected="selected" ' }
			$thevalue = $curcountry;
			$theopt = $curcountry;
			$theopt =~ s/\_/ /g;
			$cntropt .= qq~<option value="$thevalue"$selektet>$theopt</option>\n~;
			if(-e ("$vardir/$curcountry.txt")) {
				fopen(FILE, "$vardir/$curcountry.txt");
				@states = <FILE>;
				fclose(FILE);
				chomp @states;
				$statopt{$curcountry} = qq~<select name="state" id="state" style="vertical-align: middle;">~;
				$statopt{$curcountry} .= qq~<option value=""></option>~;
				foreach $curstate (@states) {
					($stateinit, $curstat) = split(/\,/, $curstate);
					$curstate =~ s/ //gi;
					$curstate =~ s/\n//gi;
					$curstate =~ s/\r//gi;
					$stateselektet = "";
					if($curstate eq ${$uid.$user}{'state'}) { $stateselektet = ' selected="selected" ' }
					$statevalue = $curstate;
					$stateopt = $curstat;
					$stateopt =~ s/\_/ /g;
					$statopt{$curcountry} .= qq~<option value="$statevalue"$stateselektet>$stateopt</option>~;
				}
				$statopt{$curcountry} .= qq~</select>~;
				$tmpstat = $statopt{$curcountry};
				$tmpstat =~ s~(\W)~\\$1~g;
				$statvar .= qq~"$tmpstat", ~;
			}
			else {
				$statopt{$curcountry} = qq~<input type="hidden" name="state" id="state" value="" style="vertical-align: middle;" />~;
				$tmpstat = $statopt{$curcountry};
				$tmpstat =~ s~(\W)~\\$1~g;
				$statvar .= qq~"$tmpstat", ~;
			}
		}
	}
	$statvar .= qq~"''"~;

	if(!${$uid.$user}{'country'}) { $thisflag = "Noflag" }
	else { $thisflag = ${$uid.$user}{'country'} }

	if(${$uid.$user}{'gender'} eq "Male") { $pin = "$malepin"; }
	elsif(${$uid.$user}{'gender'} eq "Female") { $pin = "$femalepin"; }
	else { $pin = "$napin"; }

	$tmpxcord = 0;
	$tmpycord = 0;
	if(${$uid.$user}{'xcoord'}) {$tmpxcord = ${$uid.$user}{'xcoord'};}
	if(${$uid.$user}{'ycoord'}) {$tmpycord = ${$uid.$user}{'ycoord'};}

	$yymain .= qq~
<script language="JavaScript1.2" type="text/javascript">
<!--
function checkForm(theForm) {
if (theForm.location.value == "" || theForm.location.value == "_" || theForm.location.value == " ") { alert("$maptxt{'11'}"); theForm.location.focus(); return false }
if (theForm.country.value == "Noflag") { alert("$maptxt{'12'}"); theForm.country.focus(); return false }
if (theForm.xcoord.value < 1 && theForm.ycoord.value < 1) { alert("$maptxt{'13'}"); return false }
return true
}
//-->
</script>

<div class="bordercolor" style="padding: 0px; padding-top: 0px; padding-bottom: 0px; width: 100%;">
<form action="$scripturl?action=profileLocation2;username=$INFO{'username'};sid=$INFO{'sid'}" method="post" name="creator" onsubmit="if(!checkForm(this)) {return false}">
<table class="bordercolor" cellspacing="1" cellpadding="4" width="100%" align="center" border="0">
	<tr class="windowbg">
		<td width="220" align="left"><b>$maptxt{'03'}: </b><br /><span class="small">$maptxt{'03a'}</span></td>
		<td align="left"><input type="text" maxlength="30" name="location" size="30" value="${$uid.$user}{'location'}" /></td>
	</tr>
	<tr class="windowbg">
		<td width="220" align="left"><b>$maptxt{'04'}: </b><br /><span class="small">$maptxt{'04a'}</span></td>
		<td align="left">
		<select style="font-size: 9px; vertical-align: middle;" name="country" onchange="ShowFlag()">
		<option value="Noflag"></option>
		$cntropt
		</select>&nbsp;
		<img src="$modimgurl/yamms/flag/$thisflag.gif" name="flags" id="flags" border="0" style="vertical-align: middle;" />&nbsp;
		<span name="viewstate" id="viewstate">$statopt{$thisflag}</span>
		</td>
	</tr>
	<tr class="windowbg">
		<td width="220" align="left"><b>$maptxt{'02'}: </b><br /><span class="small">$maptxt{'02a'}</span></td>
		<td align="left">
		<select style="font-size: 9px;" name="mapselect" onchange="ShowMap()">
		$contopt
		</select>
		<input type="hidden" name="xcoord" id="xcoord" value="${$uid.$user}{'xcoord'}" />
		<input type="hidden" name="ycoord" id="ycoord" value="${$uid.$user}{'ycoord'}" />
		</td>
	</tr>
	<tr class="windowbg2">
		<td colspan="2" align="right">
		<iframe id="map" name="map" width="550" height="430" marginwidth="0" marginheight="0" border="0" frameborder="0"></iframe>
		</td>
	</tr>
	<tr class="catbg">
		<td height="30" valign="middle" align="center" colspan="2">
		<input type="submit" name="moda" value="$profile_txt{'88'}" />
		</td>
	</tr>
</table>
</form>
</div>

<script language="JavaScript1.2" type="text/javascript">
<!--
	function ShowFlag() {

	state_data = new Array ( $statvar );
	var thestate = document.creator.country.selectedIndex;

		document.images.flags.src="$modimgurl/yamms/flag/"+document.creator.country.options[document.creator.country.selectedIndex].value + ".gif";
		document.getElementById("viewstate").innerHTML = state_data[thestate];
	}

	function ShowMap() {
		var vismap = "<html><head><link rel='stylesheet' href='$extpagstyle' type='text/css' /></head><body class='windowbg2'> ";
		vismap += "<img src='$modimgurl/yamms/maps/" + document.creator.mapselect.options[document.creator.mapselect.selectedIndex].value + ".gif' width='550' height='430' name='mapview' id='mapview' border='0' style='position: absolute; top: 0px; left: 0px; cursor: crosshair; pointer: crosshair;' alt='' onclick='MapClick(event)' /> ";
		vismap += "<img src='$modimgurl/yamms/$pin.gif' id='nmarker' style='z-index: 2;'> ";
		vismap += "<script language='JavaScript1.2' type='text/javascript'> "
		vismap += "document.getElementById('nmarker').style.visibility = 'visible'; "
		vismap += "document.getElementById('nmarker').style.position = 'absolute'; "
		vismap += "document.getElementById('nmarker').style.left = $tmpxcord + 'px'; "
		vismap += "document.getElementById('nmarker').style.top = $tmpycord - 8 + 'px'; "
		vismap += "function MapClick(event) \{ "
		vismap += "xcoor = (event.clientX); "
		vismap += "ycoor = (event.clientY); "
		vismap += "document.getElementById('nmarker').style.visibility = 'visible'; "
		vismap += "document.getElementById('nmarker').style.position = 'absolute'; "
		vismap += "document.getElementById('nmarker').style.left = xcoor + 'px'; "
		vismap += "document.getElementById('nmarker').style.top = ycoor - 8 + 'px'; "
		vismap += "parent.document.creator.ycoord.value = ycoor; "
		vismap += "parent.document.creator.xcoord.value = xcoor; "
		vismap += "\} "
		vismap += "<\\/script> <\\/body> <\\/html>";

		map.document.open("text/html");
		map.document.write(vismap);
		map.document.close();
	}

	ShowMap()
//-->
</script>
~;
	$yytitle = qq~$maptxt{'37'} $user - $profile_txt{'227'}~;
	&template;
	exit;
}

sub ModifyProfileLocation2 {
	require "$sourcedir/Profile.pl";
	# Check that profile-editing session is still valid
	&SidCheck;
	# Get the form values
	my( %member, $key, $value, $newpassemail, @memberlist, $a, @check_settings, @reserve, $matchword, $matchcase, $matchuser, $matchname, $namecheck, $reserved, $reservecheck, @dirdata, $filename, @entries, $entry, $umail, @members, $tempname );
	while( ($key,$value) = each(%FORM) ) {
		$value =~ s~\A\s+~~;
		$value =~ s~\s+\Z~~;
		$value =~ s~[\n\r]~~g;
		$member{$key} = $value;
	}
	my $user = $INFO{'username'};
	if (!${$uid.$user}{'password'}){&LoadUser($INFO{'username'});}

	# make sure this person has access to this profile
	if($user ne $INFO{'username'} && !$iamadmin) { &fatal_error($profile_txt{'80'}); }
	if( !$iamadmin ) {
		$member{'username'} = $INFO{'username'};
		$member{'settings6'} = ${$uid.$user}{'postcount'};
		$member{'settings7'} = ${$uid.$user}{'position'};
		$member{'addgroup'} = ${$uid.$user}{'addgroups'};
	}

	# Time to print the changes to the username.vars file
	${$uid.$user}{'location'} = "$member{'location'}";
	${$uid.$user}{'country'} = "$member{'country'}";
	${$uid.$user}{'state'} = "$member{'state'}";
	${$uid.$user}{'map'} = "$member{'mapselect'}";
	${$uid.$user}{'xcoord'} = "$member{'xcoord'}";
	${$uid.$user}{'ycoord'} = "$member{'ycoord'}";
	&UserAccount($user,"update");

	if(-e ("$vardir/mmlist.txt")) {
		fopen(MMLIST, "$vardir/mmlist.txt");
		@mmlist = <MMLIST>;
		fclose(MMLIST);
	}

	fopen(MMLIST, ">$vardir/mmlist.txt", 1);
	foreach $mmbname (@mmlist) {
		chomp $mmbname;
		if($mmbname ne $user) { print MMLIST "$mmbname\n"; }
	}
	print MMLIST "$user\n";
	fclose(MMLIST);

	$yySetLocation = qq~$scripturl?action=profileContacts;username=$INFO{'username'};sid=$INFO{'sid'}~;
	&redirectexit;
}

sub ViewLocation {
	require "$sourcedir/Profile.pl";

	if($iamguest) { &fatal_error("$profile_txt{'223'}"); }
	if ($INFO{'username'} =~ /\//){ &fatal_error("$profile_txt{'224'}" ); }
	if ($INFO{'username'} =~ /\\/){ &fatal_error("$profile_txt{'225'}" ); }
	if(!-e ("$memberdir/$INFO{'username'}.vars")){ &fatal_error("$profile_txt{'453'} -- $INFO{'username'}"); }

	@menucolors = qw(catbg catbg catbg);
	$menucolors[1] = "titlebg";

	# get the member's info
	my $user = $INFO{'username'};
	if (!${$uid.$user}{'password'}){&LoadUser($user);}
	&LoadMiniUser($user);
	&FormatUserName($user);

	$memcontinent = "${$uid.$user}{'map'}";
	$membx = ${$uid.$user}{'xcoord'} + 1;
	$membx .= qq~px~;
	$memby = ${$uid.$user}{'ycoord'} - 8;
	$memby .= qq~px~;

	if(${$uid.$user}{'gender'} eq "Male") { $pin = "$malepin"; $pin .= "_on"; }
	elsif(${$uid.$user}{'gender'} eq "Female") { $pin = "$femalepin"; $pin .= "_on"; }
	else { $pin = "$napin"; $pin .= "_on"; }

	$thestate = "";
	if(${$uid.$user}{'state'}) {
		(undef, $tmpstate) = split(/\,/, ${$uid.$user}{'state'});
		$tmpstate =~ s/\_/ /g;
		$thestate = qq~, $tmpstate~;
	}
	$thecountry = ${$uid.$user}{'country'};
	$thecountry =~ s/\_/ /g;

	$yymain .= qq~
<div align="center">
~;
	&ProfileMenu;

$yymain .= qq~
<div class="bordercolor" style="padding: 1px; padding-bottom: 0px; width: 552px;">
<table class="windowbg" border="0" cellpadding="2" cellspacing="0" align="center" width="100%">
  <tr>
	<td width="25%" align="left">&nbsp;<b>$profile_txt{'68'}:</b></td>
	<td width="75%" align="left">${$uid.$user}{'realname'}</td>
  </tr>
  <tr>
	<td width="25%" align="left">&nbsp;<b>$maptxt{'03'}:</b></td>
	<td width="75%" align="left">${$uid.$user}{'location'}$thestate</td>
  </tr>
  <tr>
	<td width="25%" align="left">&nbsp;<b>$maptxt{'04'}:</b></td>
	<td width="75%" align="left">$thecountry</td>
  </tr>
</table>
</div>
<div style="position: relative; overflow: hidden; background-color: #f0f0f0; width: 552px; height: 432px; padding: 0px; border: 1px black solid;">
	<img src="$modimgurl/yamms/maps/$memcontinent.gif" width="550" height="430" alt="" style="position: relative; top: 0px; left: 0px; z-index: 1;" />
	<img src="$modimgurl/yamms/$pin.gif" alt="" style="position: absolute; top: $memby; left: $membx; z-index: 2; border: 0;" />
</div>
</div>
~;
	$yytitle = "$profile_txt{'92'} $user";
	&template;
	exit;
}

sub WriteLastIps {
	if (!${$uid.$username}{'password'}){&LoadUser($username);}
	my $yamip1 = $user_ip;
	my ($yamip2, $yamip3, undef) = split(/\|/, ${$uid.$username}{'lastips'});

	if($yamip1 ne $yamip2) {
		${$uid.$username}{'lastips'} = qq~$yamip1|$yamip2|$yamip3~;
		&UserAccount($username,"update");
	}
}

sub MemberListSetup {
	$listtogl = $INFO{'listtogl'};
	my $user = $username;
	if (!${$uid.$user}{'password'}){&LoadUser($username);}
	my($listonline, $listlocation, $listmail, $listwww, $listmsn, $listicq, $listyim, $listaim, $listgender, $listsetup, $listgtalk, $listskype, $listpm);
	if(!${$uid.$user}{'memberlist'}) {
		$listonline=0; $listlocation=0; $listmail=0; $listwww=0; $listmsn=0; $listicq=0; $listyim=0; $listaim=0; $listgender=0; $listsetup=0; $listgtalk=0; $listskype=0; $listpm=0;
	}
	else {
		($listonline, $listlocation, $listmail, $listwww, $listmsn, $listicq, $listyim, $listaim, $listgender, $listsetup, $listgtalk, $listskype, $listpm) = split(/\|/, ${$uid.$user}{'memberlist'});
	}
	if($INFO{'listdo'} eq "online") {
		${$uid.$user}{'memberlist'} = qq~$listtogl|$listlocation|$listmail|$listwww|$listmsn|$listicq|$listyim|$listaim|$listgender|$listsetup|$listgtalk|$listskype|$listpm~;
	}
	elsif($INFO{'listdo'} eq "location") {
		${$uid.$user}{'memberlist'} = qq~$listonline|$listtogl|$listmail|$listwww|$listmsn|$listicq|$listyim|$listaim|$listgender|$listsetup|$listgtalk|$listskype|$listpm~;
	}
	elsif($INFO{'listdo'} eq "mail") {
		${$uid.$user}{'memberlist'} = qq~$listonline|$listlocation|$listtogl|$listwww|$listmsn|$listicq|$listyim|$listaim|$listgender|$listsetup|$listgtalk|$listskype|$listpm~;
	}
	elsif($INFO{'listdo'} eq "www") {
		${$uid.$user}{'memberlist'} = qq~$listonline|$listlocation|$listmail|$listtogl|$listmsn|$listicq|$listyim|$listaim|$listgender|$listsetup|$listgtalk|$listskype|$listpm~;
	}
	elsif($INFO{'listdo'} eq "msn") {
		${$uid.$user}{'memberlist'} = qq~$listonline|$listlocation|$listmail|$listwww|$listtogl|$listicq|$listyim|$listaim|$listgender|$listsetup|$listgtalk|$listskype|$listpm~;
	}
	elsif($INFO{'listdo'} eq "icq") {
		${$uid.$user}{'memberlist'} = qq~$listonline|$listlocation|$listmail|$listwww|$listmsn|$listtogl|$listyim|$listaim|$listgender|$listsetup|$listgtalk|$listskype|$listpm~;
	}
	elsif($INFO{'listdo'} eq "yim") {
		${$uid.$user}{'memberlist'} = qq~$listonline|$listlocation|$listmail|$listwww|$listmsn|$listicq|$listtogl|$listaim|$listgender|$listsetup|$listgtalk|$listskype|$listpm~;
	}
	elsif($INFO{'listdo'} eq "aim") {
		${$uid.$user}{'memberlist'} = qq~$listonline|$listlocation|$listmail|$listwww|$listmsn|$listicq|$listyim|$listtogl|$listgender|$listsetup|$listgtalk|$listskype|$listpm~;
	}
	elsif($INFO{'listdo'} eq "gender") {
		${$uid.$user}{'memberlist'} = qq~$listonline|$listlocation|$listmail|$listwww|$listmsn|$listicq|$listyim|$listaim|$listtogl|$listsetup|$listgtalk|$listskype|$listpm~;
	}
	elsif($INFO{'listdo'} eq "setup") {
		${$uid.$user}{'memberlist'} = qq~$listonline|$listlocation|$listmail|$listwww|$listmsn|$listicq|$listyim|$listaim|$listgender|$listtogl|$listgtalk|$listskype|$listpm~;
	}
	elsif($INFO{'listdo'} eq "gtalk") {
		${$uid.$user}{'memberlist'} = qq~$listonline|$listlocation|$listmail|$listwww|$listmsn|$listicq|$listyim|$listaim|$listgender|$listsetup|$listtogl|$listskype|$listpm~;
	}
	elsif($INFO{'listdo'} eq "skype") {
		${$uid.$user}{'memberlist'} = qq~$listonline|$listlocation|$listmail|$listwww|$listmsn|$listicq|$listyim|$listaim|$listgender|$listsetup|$listgtalk|$listtogl|$listpm~;
	}
	elsif($INFO{'listdo'} eq "pm") {
		${$uid.$user}{'memberlist'} = qq~$listonline|$listlocation|$listmail|$listwww|$listmsn|$listicq|$listyim|$listaim|$listgender|$listsetup|$listgtalk|$listskype|$listtogl~;
	}

	&UserAccount($user,"update");
	my $mparams = "";
	if($INFO{'sort'}) {$mparams = qq~;sort=$INFO{'sort'}~;}
	if($INFO{'thesort'}) {$mparams .= qq~;thesort=$INFO{'thesort'}~;}
	if($INFO{'letter'}) {$mparams .= qq~;letter=$INFO{'letter'}~;}
	if($INFO{'start'}) {$mparams .= qq~;start=$INFO{'start'}~;}
	$yySetLocation = qq~$scripturl?action=ml$mparams~; 
	&redirectexit;
}

1;